'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Hover = function (_Component) {
  _inherits(Hover, _Component);

  function Hover() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Hover);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Hover.__proto__ || Object.getPrototypeOf(Hover)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isHovered: false,
      isDelayHovered: false
    }, _this._delayHoverTimeout = null, _this._mouseenter = function (e) {

      var isHovered = true;
      _this.setState({ isHovered: isHovered });
      _this.props.onStateChange({ isHovered: isHovered });
      _this._delayHoverTimeout = setTimeout(function () {
        _this.setState({ isHovered: isHovered, isDelayHovered: true });
        _this.props.onStateChange({ isHovered: isHovered, isDelayHovered: true });
      }, _this.props.delay);
    }, _this._mouseleave = function (e) {
      var isHovered = false;
      var isDelayHovered = false;
      clearTimeout(_this._delayHoverTimeout);
      _this.setState({ isHovered: isHovered, isDelayHovered: isDelayHovered });
      _this.props.onStateChange({ isHovered: isHovered, isDelayHovered: isDelayHovered });
    }, _this.componentWillMount = function () {
      if (_this.props.initialOpen) {
        _this.setState({
          isHovered: true,
          isDelayHovered: true
        });
      }
    }, _this.componentWillUnmount = function () {
      clearTimeout(_this._delayHoverTimeout);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Hover, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          tagName = _props.tagName,
          className = _props.className,
          style = _props.style;
      var _state = this.state,
          isHovered = _state.isHovered,
          isDelayHovered = _state.isDelayHovered;

      var onMouseEnter = this._mouseenter;
      var onMouseLeave = this._mouseleave;
      return _react2.default.createElement(tagName, {
        className: className,
        style: style,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave
      }, typeof children === 'function' ? children({
        isHovered: isHovered, isDelayHovered: isDelayHovered
      }) : children);
    }
  }]);

  return Hover;
}(_react.Component);

Hover.defaultProps = {
  style: {},
  tagName: 'div',
  className: '',
  delay: 0,
  initialOpen: false,
  onStateChange: function onStateChange() {}
};
exports.default = Hover;