import React, { Component } from 'react'

class Hover extends Component {
  static defaultProps = {
    style: {},
    tagName: 'div',
    className: '',
    delay: 0,
    initialOpen: false,
    onStateChange: () => { }
  }

  state = {
    isHovered: false,
    isDelayHovered: false
  }

  _delayHoverTimeout = null

  _mouseenter = (e) => {

    const isHovered = true
    this.setState({ isHovered })
    this.props.onStateChange({ isHovered })
    this._delayHoverTimeout = setTimeout(() => {
      this.setState({ isHovered, isDelayHovered: true })
      this.props.onStateChange({ isHovered, isDelayHovered: true })
    }, this.props.delay)
  }

  _mouseleave = (e) => {
    const isHovered = false
    const isDelayHovered = false
    clearTimeout(this._delayHoverTimeout)
    this.setState({ isHovered, isDelayHovered })
    this.props.onStateChange({ isHovered, isDelayHovered })
  }

  componentWillMount = () => {
    if (this.props.initialOpen) {
      this.setState({
        isHovered: true,
        isDelayHovered: true
      })
    }
  }

  componentWillUnmount = () => {
    clearTimeout(this._delayHoverTimeout)
  }

  render() {
    const { children, tagName, className, style } = this.props
    const { isHovered, isDelayHovered } = this.state
    const onMouseEnter = this._mouseenter
    const onMouseLeave = this._mouseleave
    return React.createElement(tagName, {
      className,
      style,
      onMouseEnter,
      onMouseLeave
    }, typeof children === 'function' ? children({
      isHovered, isDelayHovered
    }) : children)
  }
}

export default Hover