import React from 'react'
import Hover from './Hover'

const withHover = (Children, options = {}) => (props) => {
  const { tagName, className, style } = options
  return (
    <Hover {...{ tagName, className, style }}>
      {({ isHovered }) => <Children {...props} isHovered={isHovered} />}
    </Hover>
  )
}

export {
  Hover,
  withHover
}